require_relative "version"

class DietaNueva_t

  attr_accessor :titulo, :porcediarios, :platos, :porcentajes

  def initialize(titulo, &block)
    self.titulo = titulo
    self.porcediarios = []
    self.platos = []
    self.porcentajes = []

    if block_given?
      if block.arity == 1
        yield self
      else
        instance_eval(&block)
      end
    end
  end

  def to_s
    mostrar = titulo
    mostrar << "\n#{'=' * titulo.size}\n"

    mostrar << "\nPorcentajes recomendados de ingesta."
    porcediarios.each do |porcediario|
      mostrar << "#{porcediario}"
    end

    platos.each_with_index do |plato, i|
      mostrar << "#{i + 1} #{plato}"
    end


    mostrar << "\nV.C.T. y porcentajes: "
    porcentajes.each do |porcentaje|
      mostrar << " #{porcentaje}"
    end

    mostrar << "\n\n"
	end

  def porcediario(options = {})
    porcediarios << "\nMin: #{options[:minimo]}" if options[:minimo]
    porcediarios << "\nMax: #{options[:maximo]}\n\n" if options[:maximo]
  end

  def plato(options = {})

    plato = " #{options[:descripcion]}." if options[:descripcion]
    plato += " #{options[:porciones]}." if options[:porciones]
    plato += " #{options[:ingengr]}.\n" if options[:ingengr]

    platos << plato
  end


  def porcentaje(options = {})

    porcentajes << "#{options[:vct]} kcal" if options[:vct]
    porcentajes << "#{options[:porcproteinas]}%" if options[:porcproteinas]
    porcentajes << "#{options[:porcgrasas]}%" if options[:porcgrasas]
    porcentajes << "#{options[:porchidratos]}%." if options[:porchidratos]
  end
end
